Index: trunk/src/lib/event/event_handler.cc
===================================================================
--- trunk/src/lib/event/event_handler.cc	(revision 9682)
+++ trunk/src/lib/event/event_handler.cc	(revision 9869)
@@ -28,4 +28,6 @@
 #include <algorithm>
 
+
+ObjectListDefinition(EventHandler);
 /**
  * @brief standard constructor
@@ -33,5 +35,5 @@
 EventHandler::EventHandler ()
 {
-  this->setClassID(CL_EVENT_HANDLER, "EventHandler");
+  this->registerObject(this, EventHandler::_objectList);
   this->setName("EventHandler");
 
Index: trunk/src/lib/event/event_handler.h
===================================================================
--- trunk/src/lib/event/event_handler.h	(revision 9682)
+++ trunk/src/lib/event/event_handler.h	(revision 9869)
@@ -21,5 +21,5 @@
 class EventHandler : public BaseObject
 {
-
+  ObjectListDeclaration(EventHandler);
 public:
   virtual ~EventHandler();
Index: trunk/src/lib/event/event_listener.cc
===================================================================
--- trunk/src/lib/event/event_listener.cc	(revision 9682)
+++ trunk/src/lib/event/event_listener.cc	(revision 9869)
@@ -19,4 +19,5 @@
 #include "event_handler.h"
 
+ObjectListDefinition(EventListener);
 /**
  * @brief standard constructor
@@ -24,5 +25,5 @@
 EventListener::EventListener ()
 {
-  this->setClassID(CL_EVENT_LISTENER, "EventListener");
+  this->registerObject(this, EventListener::_objectList);
 }
 
Index: trunk/src/lib/event/event_listener.h
===================================================================
--- trunk/src/lib/event/event_listener.h	(revision 9682)
+++ trunk/src/lib/event/event_listener.h	(revision 9869)
@@ -12,7 +12,8 @@
 
 //! A class for event listener
-class EventListener : virtual public BaseObject {
-
- public:
+class EventListener : virtual public BaseObject
+{
+  ObjectListDeclaration(EventListener);
+public:
   EventListener();
   virtual ~EventListener();
Index: trunk/src/lib/event/key_mapper.cc
===================================================================
--- trunk/src/lib/event/key_mapper.cc	(revision 9682)
+++ trunk/src/lib/event/key_mapper.cc	(revision 9869)
@@ -25,5 +25,5 @@
 #include "globals.h"
 #include "parser/ini_parser/ini_parser.h"
-#include "util/preferences.h"
+#include "parser/preferences/preferences.h"
 #include "key_names.h"
 #include "event_def.h"
@@ -32,5 +32,5 @@
 
 
-
+ObjectListDefinition(KeyMapper);
 
 /* initialize all variables to a reasonable value*/
@@ -116,5 +116,5 @@
 KeyMapper::KeyMapper ()
 {
-   this->setClassID(CL_KEY_MAPPER, "KeyMapper");
+  this->registerObject(this, KeyMapper::_objectList);
 }
 
Index: trunk/src/lib/event/key_mapper.h
===================================================================
--- trunk/src/lib/event/key_mapper.h	(revision 9682)
+++ trunk/src/lib/event/key_mapper.h	(revision 9869)
@@ -16,4 +16,5 @@
 class KeyMapper : public BaseObject
 {
+  ObjectListDeclaration(KeyMapper);
 public:
   //! A mapping from key-name to key-id
Index: trunk/src/lib/graphics/Makefile.am
===================================================================
--- trunk/src/lib/graphics/Makefile.am	(revision 9682)
+++ trunk/src/lib/graphics/Makefile.am	(revision 9869)
@@ -6,6 +6,9 @@
 libORXgraphics_a_SOURCES = \
 		graphics_engine.cc \
+		graphics_effect.cc \
 		light.cc \
 		shader.cc \
+		shader_data.cc \
+		resource_shader.cc \
 		\
 		render2D/render_2d.cc \
@@ -19,21 +22,13 @@
 		text_engine/font.cc \
 		text_engine/font_data.cc \
-		\
-		effects/graphics_effect.cc \
-		effects/atmospheric_engine.cc \
-		effects/weather_effect.cc \
-		effects/sun_effect.cc \
-		effects/fog_effect.cc \
-		effects/volfog_effect.cc \
-		effects/rain_effect.cc \
-		effects/snow_effect.cc \
-		effects/cloud_effect.cc \
-		effects/lightning_effect.cc \
-		effects/lense_flare.cc
+		text_engine/resource_font.cc
 
 noinst_HEADERS =\
  		graphics_engine.h \
+ 		graphics_effect.h \
 		light.h \
 		shader.h \
+		shader_data.h \
+		resource_shader.h \
 		\
 		render2D/render_2d.h \
@@ -47,17 +42,6 @@
 		text_engine/font.h \
 		text_engine/font_data.h \
-		text_engine/default_font.xpm \
-		\
-		effects/graphics_effect.h \
-		effects/atmospheric_engine.h \
-		effects/weather_effect.h \
-		effects/sun_effect.h \
-		effects/fog_effect.h \
-		effects/volfog_effect.h \
-		effects/rain_effect.h \
-		effects/snow_effect.h \
-		effects/cloud_effect.h \
-		effects/lightning_effect.h \
-		effects/lense_flare.h
+		text_engine/resource_font.h \
+		text_engine/default_font.xpm
 
 
Index: trunk/src/lib/graphics/graphics_effect.cc
===================================================================
--- trunk/src/lib/graphics/graphics_effect.cc	(revision 9869)
+++ trunk/src/lib/graphics/graphics_effect.cc	(revision 9869)
@@ -0,0 +1,69 @@
+
+
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+### File Specific:
+   main-programmer: Patrick Boenzli
+*/
+
+#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_GRAPHICS
+
+
+#include "graphics_effect.h"
+
+#include "util/loading/load_param.h"
+
+ObjectListDefinition(GraphicsEffect);
+
+/**
+ * @param root The XML-element to load the GraphicsEffect from
+
+  @todo what to do, if no GraphicsEffect-Slots are open anymore ???
+ */
+GraphicsEffect::GraphicsEffect(const TiXmlElement* root) {
+  this->registerObject(this, GraphicsEffect::_objectList);
+    this->bActivated = false;
+}
+
+
+/**
+ *  destroys a GraphicsEffect
+ */
+GraphicsEffect::~GraphicsEffect() {
+}
+
+
+/**
+ * @param root The XML-element to load the GraphicsEffect from
+ */
+void GraphicsEffect::loadParams(const TiXmlElement* root) {
+    BaseObject::loadParams(root);
+}
+
+
+/**
+ *  initializes the graphics effect
+ */
+void GraphicsEffect::init() {}
+
+
+
+/**
+ * draws the effect, if needed
+ */
+void GraphicsEffect::draw() const {}
+
+
+
+/**
+ * ticks the effect if there is any time dependancy
+ */
+void GraphicsEffect::tick(float dt) {}
Index: trunk/src/lib/graphics/graphics_effect.h
===================================================================
--- trunk/src/lib/graphics/graphics_effect.h	(revision 9869)
+++ trunk/src/lib/graphics/graphics_effect.h	(revision 9869)
@@ -0,0 +1,40 @@
+/**
+ * @file graphics_effect.h
+ *  abstract type of graphical effects
+ */
+
+#ifndef _GRAPHICS_EFFECT
+#define _GRAPHICS_EFFECT
+
+#include "base_object.h"
+
+class TiXmlElement;
+
+//! A class that handles GraphicsEffects. The GraphicsEffectManager operates on this.
+class GraphicsEffect : public BaseObject {
+  ObjectListDeclaration(GraphicsEffect);
+  public:
+    GraphicsEffect(const TiXmlElement* root = NULL);
+    virtual ~GraphicsEffect();
+
+    virtual void loadParams(const TiXmlElement* root);
+
+    virtual void init();
+
+    virtual void activate() = 0;
+    virtual void deactivate() = 0;
+
+    virtual void draw() const;
+    virtual void tick(float dt);
+
+    inline bool isActivated() const {
+        return this->bActivated;
+    }
+
+
+protected:
+    bool              bActivated;
+};
+
+
+#endif /* _GRAPHICS_EFFECT */
Index: trunk/src/lib/graphics/graphics_engine.cc
===================================================================
--- trunk/src/lib/graphics/graphics_engine.cc	(revision 9682)
+++ trunk/src/lib/graphics/graphics_engine.cc	(revision 9869)
@@ -17,5 +17,4 @@
 
 #include "graphics_engine.h"
-#include "util/loading/resource_manager.h"
 #include "state.h"
 
@@ -28,5 +27,5 @@
 #include "debug.h"
 
-#include "util/preferences.h"
+#include "parser/preferences/preferences.h"
 #include "substring.h"
 #include "text.h"
@@ -35,15 +34,12 @@
 #include "texture.h"
 
-#include "effects/graphics_effect.h"
-#include "effects/fog_effect.h"
-#include "effects/lense_flare.h"
+#include "graphics_effect.h"
 
 #include "shell_command.h"
-
+#include "loading/load_param_xml.h"
 
 #include "parser/tinyxml/tinyxml.h"
 #include "util/loading/load_param.h"
 #include "util/loading/factory.h"
-#include "class_list.h"
 
 #ifdef __WIN32__
@@ -54,4 +50,6 @@
 SHELL_COMMAND(fps, GraphicsEngine, toggleFPSdisplay);
 
+ObjectListDefinition(GraphicsEngine);
+
 /**
  * @brief standard constructor
@@ -59,5 +57,5 @@
 GraphicsEngine::GraphicsEngine ()
 {
-  this->setClassID(CL_GRAPHICS_ENGINE, "GraphicsEngine");
+  this->registerObject(this, GraphicsEngine::_objectList);
   this->setName("GraphicsEngine");
 
@@ -117,5 +115,5 @@
 {
   LoadParamXML(root, "GraphicsEffect", this, GraphicsEngine, loadGraphicsEffects)
-  .describe("loads a graphics effect");
+   .describe("loads a graphics effect");
 }
 
@@ -590,10 +588,8 @@
 
   // tick the graphics effects
-  if (this->graphicsEffects != NULL || (this->graphicsEffects = ClassList::getList(CL_GRAPHICS_EFFECT)) != NULL)
-  {
-    std::list<BaseObject*>::const_iterator it;
-    for (it = this->graphicsEffects->begin(); it != this->graphicsEffects->end(); it++)
-      dynamic_cast<GraphicsEffect*>(*it)->tick(dt);
-  }
+  for (ObjectList<GraphicsEffect>::const_iterator it = GraphicsEffect::objectList().begin();
+       it != GraphicsEffect::objectList().end();
+       ++it)
+    (*it)->tick(dt);
 }
 
@@ -688,6 +684,6 @@
   {
     case EV_VIDEO_RESIZE:
-      this->resolutionChanged(event.resize);
-      break;
-  }
-}
+    this->resolutionChanged(event.resize);
+    break;
+  }
+}
Index: trunk/src/lib/graphics/graphics_engine.h
===================================================================
--- trunk/src/lib/graphics/graphics_engine.h	(revision 9682)
+++ trunk/src/lib/graphics/graphics_engine.h	(revision 9869)
@@ -30,4 +30,5 @@
 class GraphicsEngine : public EventListener
 {
+  ObjectListDeclaration(GraphicsEngine);
   public:
     virtual ~GraphicsEngine();
Index: trunk/src/lib/graphics/importer/Makefile.am
===================================================================
--- trunk/src/lib/graphics/importer/Makefile.am	(revision 9682)
+++ trunk/src/lib/graphics/importer/Makefile.am	(revision 9869)
@@ -4,39 +4,44 @@
 noinst_LIBRARIES = libORXimporter.a libtc.a
 
-libORXimporter_a_SOURCES = model.cc \
-			   interactive_model.cc \
-			   md_model_structure.cc \
-                           vertex_array_model.cc \
-                           grid.cc \
-                           static_model.cc \
-                           objModel.cc \
-                           primitive_model.cc \
-                           height_map.cc \
-                           bsp_manager.cc \
-                           bsp_file.cc \
-                           bsp_tree_node.cc \
-                           bsp_tree_leaf.cc \
-                           \
-                           material.cc \
-                           texture.cc \
-                           texture_data.cc \
-                           texture_sequence.cc \
-                           media_container.cc \
-                           movie_player.cc \
-                           \
-                           bsp_manager.cc \
-                           bsp_file.cc \
-                           bsp_tree_node.cc \
-                           bsp_tree_leaf.cc \
-                           \
-                           md2/md2Model.cc \
-                           \
-                           md3/md3_model.cc \
-                           md3/md3_animation.cc \
-                           md3/md3_animation_cfg.cc \
-                           md3/md3_bone_frame.cc \
-                           md3/md3_mesh.cc \
-                           md3/md3_data.cc \
-                           md3/md3_tag.cc
+libORXimporter_a_SOURCES = \
+		model.cc \
+		interactive_model.cc \
+		md_model_structure.cc \
+		vertex_array_model.cc \
+		grid.cc \
+		static_model.cc \
+		static_model_data.cc \
+		objModel.cc \
+		resource_obj.cc \
+		primitive_model.cc \
+		height_map.cc \
+		bsp_manager.cc \
+		bsp_file.cc \
+		bsp_tree_node.cc \
+		bsp_tree_leaf.cc \
+		\
+		material.cc \
+		texture.cc \
+		texture_data.cc \
+		resource_texture.cc \
+		texture_sequence.cc \
+		media_container.cc \
+		movie_player.cc \
+		\
+		bsp_manager.cc \
+		bsp_file.cc \
+		bsp_tree_node.cc \
+		bsp_tree_leaf.cc \
+		\
+		md2/md2Model.cc \
+		md2/resource_md2.cc
+#		\
+		md3/md3_model.cc \
+		md3/md3_animation.cc \
+		md3/md3_animation_cfg.cc \
+		md3/md3_bone_frame.cc \
+		md3/md3_mesh.cc \
+		md3/md3_data.cc \
+		md3/md3_tag.cc
 
 
@@ -54,5 +59,7 @@
 		grid.h \
 		static_model.h \
+		static_model_data.h \
 		objModel.h \
+		resource_obj.h \
 		primitive_model.h \
 		anorms.h \
@@ -63,4 +70,5 @@
 		texture.h \
 		texture_data.h \
+		resource_texture.h \
 		texture_sequence.h \
 		\
@@ -74,4 +82,5 @@
 		\
                 md2/md2Model.h \
+		md2/resource_md2.h \
                 \
                 md3/md3_model.h \
Index: trunk/src/lib/graphics/importer/bsp_file.cc
===================================================================
--- trunk/src/lib/graphics/importer/bsp_file.cc	(revision 9682)
+++ trunk/src/lib/graphics/importer/bsp_file.cc	(revision 9869)
@@ -466,5 +466,5 @@
     PRINTF(4)("BSP FILE: Name %s . \n", fileName);
 
-    absFileName = ResourceManager::getFullName(fileName);
+    absFileName = Resources::ResourceManager::getInstance()->prependAbsoluteMainPath(fileName);
 
     if(File(absFileName).exists()) {
@@ -481,5 +481,5 @@
     strncat (fileName, ext, strlen(fileName));
 
-    absFileName = ResourceManager::getFullName(fileName);
+    absFileName = Resources::ResourceManager::getInstance()->prependAbsoluteMainPath(fileName);
 
     if(File(absFileName).exists()) {
@@ -496,5 +496,5 @@
     strncat (fileName, ext, strlen(fileName));
 
-    absFileName = ResourceManager::getFullName(fileName);
+    absFileName = Resources::ResourceManager::getInstance()->prependAbsoluteMainPath(fileName);
 
     if(File(absFileName).exists()) {
@@ -511,5 +511,5 @@
     strncat (fileName, ext, strlen(fileName));
 
-    absFileName = ResourceManager::getFullName(fileName);
+    absFileName = Resources::ResourceManager::getInstance()->prependAbsoluteMainPath(fileName);
 
     if(File(absFileName).exists()) {
@@ -524,5 +524,5 @@
     strcpy(ext, ".TGA");
     strncat (fileName, ext, strlen(fileName));
-    absFileName = ResourceManager::getFullName(fileName);
+    absFileName = Resources::ResourceManager::getInstance()->prependAbsoluteMainPath(fileName);
 
     if(File(absFileName).exists()/*stat( absFileName.c_str() , &results) == 0*/) {
@@ -537,5 +537,5 @@
     strcpy(ext, ".jpg");
     strncat (fileName, ext, strlen(fileName));
-    absFileName = ResourceManager::getFullName(fileName);
+    absFileName = Resources::ResourceManager::getInstance()->prependAbsoluteMainPath(fileName);
     if(File(absFileName).exists()) {
       PRINTF(4)("BSP FILE: gefunden . \n");
@@ -551,5 +551,5 @@
     strcpy(ext, ".JPG");
     strncat (fileName, ext, strlen(fileName));
-    absFileName = ResourceManager::getFullName(fileName);
+    absFileName = Resources::ResourceManager::getInstance()->prependAbsoluteMainPath(fileName);
     if(File(absFileName).exists()) {
       PRINTF(4)("BSP FILE: gefunden . \n");
@@ -566,5 +566,5 @@
     strcpy(ext, ".bmp");
     strncat (fileName, ext, strlen(fileName));
-    absFileName = ResourceManager::getFullName(fileName);
+    absFileName = Resources::ResourceManager::getInstance()->prependAbsoluteMainPath(fileName);
 
     if(File(absFileName).exists()) {
@@ -580,5 +580,5 @@
     strcpy(ext, ".BMP");
     strncat (fileName, ext, strlen(fileName));
-    absFileName = ResourceManager::getFullName(fileName);
+    absFileName = Resources::ResourceManager::getInstance()->prependAbsoluteMainPath(fileName);
 
     if(File(absFileName).exists()) {
@@ -611,5 +611,5 @@
   this->testSurf = NULL;
 
-  this->testSurf = IMG_Load(ResourceManager::getFullName(mat).c_str());
+  this->testSurf = IMG_Load(Resources::ResourceManager::getInstance()->prependAbsoluteMainPath(mat).c_str());
   if(this->testSurf != NULL) {
     if(this->testSurf->format->Amask != 0 ) tmpAMat.alpha = true;
Index: trunk/src/lib/graphics/importer/bsp_manager.cc
===================================================================
--- trunk/src/lib/graphics/importer/bsp_manager.cc	(revision 9682)
+++ trunk/src/lib/graphics/importer/bsp_manager.cc	(revision 9869)
@@ -33,5 +33,5 @@
 #include "world_entities/player.h"
 #include "world_entities/playable.h"
-#include "util/loading/resource_manager.h"
+
 // STL Containers
 #include <vector>
@@ -41,4 +41,5 @@
 #include "world_entity.h"
 
+#include "util/loading/resource_manager.h"
 #include "util/loading/load_param.h"
 #include "util/loading/factory.h"
@@ -91,5 +92,5 @@
   this->bspFile = new BspFile();
   this->bspFile->scale =  scale;
-  if(this->bspFile->read(ResourceManager::getFullName(fileName).c_str()) == -1)
+  if(this->bspFile->read(Resources::ResourceManager::getInstance()->prependAbsoluteMainPath(fileName).c_str()) == -1)
     return -1;
 
@@ -1376,5 +1377,5 @@
     if( this->outputFraction == 1.0f) // No collision Detected
     {
-      if( this->outputAllSolid ) 
+      if( this->outputAllSolid )
       {
         this->collPlane = new plane;
Index: trunk/src/lib/graphics/importer/height_map.cc
===================================================================
--- trunk/src/lib/graphics/importer/height_map.cc	(revision 9682)
+++ trunk/src/lib/graphics/importer/height_map.cc	(revision 9869)
@@ -22,5 +22,4 @@
 #include "p_node.h"
 #include "state.h"
-#include "util/loading/resource_manager.h"
 #include "debug.h"
 
@@ -327,4 +326,5 @@
 
 
+ObjectListDefinition(HeightMap);
 
 
@@ -413,5 +413,5 @@
 void HeightMap::init(const std::string& heightMapName)
 {
-  this->setClassID(CL_HEIGHT_MAP, "HeightMap");
+  this->registerObject(this, HeightMap::_objectList);
 
   this->shiftX = 0;
Index: trunk/src/lib/graphics/importer/height_map.h
===================================================================
--- trunk/src/lib/graphics/importer/height_map.h	(revision 9682)
+++ trunk/src/lib/graphics/importer/height_map.h	(revision 9869)
@@ -29,7 +29,5 @@
 
 class SDL_Surface;
-class Vector;
 class Material;
-class PNode;
 class Texture;
 class HeightMap;
@@ -70,7 +68,9 @@
 
 
+
 //!< the height map representation itself
 class HeightMap : public VertexArrayModel
 {
+  ObjectListDeclaration(HeightMap);
   friend class Tile;
 
Index: trunk/src/lib/graphics/importer/interactive_model.cc
===================================================================
--- trunk/src/lib/graphics/importer/interactive_model.cc	(revision 9682)
+++ trunk/src/lib/graphics/importer/interactive_model.cc	(revision 9869)
@@ -22,4 +22,6 @@
 
 
+ObjectListDefinition(InteractiveModel);
+
 /**
  * standard constructor
@@ -28,5 +30,5 @@
 InteractiveModel::InteractiveModel()
 {
-  this->setClassID(CL_INTERACTIVE_MODEL, "InteractiveModel");
+  this->registerObject(this, InteractiveModel::_objectList);
 }
 
Index: trunk/src/lib/graphics/importer/interactive_model.h
===================================================================
--- trunk/src/lib/graphics/importer/interactive_model.h	(revision 9682)
+++ trunk/src/lib/graphics/importer/interactive_model.h	(revision 9869)
@@ -30,4 +30,5 @@
 class InteractiveModel : public Model
 {
+  ObjectListDeclaration(InteractiveModel);
   public:
     InteractiveModel();
@@ -38,5 +39,5 @@
     virtual void setAnimation(int animNum, int playbackMode = 0) = 0;
     virtual void setAnimation(int firstFrame, int lastFrame, int fps, int bStoppable, int animPlayback) {}
-    virtual int getAnimation() = 0;
+    virtual int getAnimation() const = 0;
 
     virtual bool isAnimationFinished() { return false; }
Index: trunk/src/lib/graphics/importer/material.cc
===================================================================
--- trunk/src/lib/graphics/importer/material.cc	(revision 9682)
+++ trunk/src/lib/graphics/importer/material.cc	(revision 9869)
@@ -25,5 +25,7 @@
 #include "loading/load_param.h"
 
-#include "util/loading/resource_manager.h"
+#include "resource_texture.h"
+
+ObjectListDefinition(Material);
 
 /**
@@ -33,5 +35,5 @@
 Material::Material (const std::string& mtlName)
 {
-  this->setClassID(CL_MATERIAL, "Material");
+  this->registerObject(this, Material::_objectList);
 
   this->setIllum(3);
@@ -90,9 +92,4 @@
   PRINTF(5)("delete Material %s.\n", this->getCName());
 
-  if (this->ambientTexture != NULL)
-    ResourceManager::getInstance()->unload(this->ambientTexture);
-  if (this->specularTexture != NULL)
-    ResourceManager::getInstance()->unload(this->specularTexture);
-
   if (this == Material::selectedMaterial)
     Material::selectedMaterial = NULL;
@@ -101,27 +98,4 @@
 
 const Material* Material::selectedMaterial = NULL;
-
-
-/// TODO FIX THIS
-// Material& Material::operator=(const Material& m)
-// {
-//   this->setIllum(m.illumModel);
-//   this->setDiffuse(m.diffuse[0],m.diffuse[1],m.diffuse[2]);
-//   this->setAmbient(m.ambient[0],m.ambient[1],m.ambient[2]);
-//   this->setSpecular(m.specular[0],m.specular[1],m.specular[2]);
-//   this->setShininess(m.shininess);
-//   this->setTransparency(m.transparency);
-//
-//   if (this->diffuseTexture != NULL)
-//     ResourceManager::getInstance()->unload(this->diffuseTexture);
-//   if (m.diffuseTexture != NULL)
-//     this->diffuseTexture = (Texture*)ResourceManager::getInstance()->copy(m.diffuseTexture);
-//   this->ambientTexture = NULL; /// FIXME
-//   this->specularTexture = NULL; /// FIXME
-//
-//   this->setName(m.getName());
-// }
-
-
 
 /**
@@ -288,17 +262,4 @@
 
 
-
-/**
- * @brief Adds a Texture Path to the List of already existing Paths
- * @param pathName The Path to add.
-*/
-void Material::addTexturePath(const std::string& pathName)
-{
-  ResourceManager::getInstance()->addImageDir(pathName);
-}
-
-// MAPPING //
-
-
 /**
  * @brief Sets the Diffuse map of this Texture.
@@ -322,5 +283,5 @@
  * @param textureNumber The Texture-Number from 0 to GL_MAX_TEXTURE_UNITS
  */
-void Material::setDiffuseMap(const TextureDataPointer& textureDataPointer, unsigned int textureNumber)
+void Material::setDiffuseMap(const TextureData::Pointer& textureDataPointer, unsigned int textureNumber)
 {
   assert(textureNumber < Material::getMaxTextureUnits());
@@ -349,9 +310,10 @@
   if (!dMap.empty())
   {
-    Texture* tex = dynamic_cast<Texture*>(ResourceManager::getInstance()->load(dMap, IMAGE, RP_GAME, (int)target));
-    if (tex != NULL)
-      this->textures[textureNumber] = *tex;
+    this->textures[textureNumber] = ResourceTexture(dMap);
+	//dynamic_cast<Texture*>(ResourceManager::getInstance()->load(dMap, IMAGE, RP_GAME, (int)target));
+/*    if (tex != NULL)
+      this->textures[textureNumber] = tex;
     else
-      this->textures[textureNumber] = Texture();
+      this->textures[textureNumber] = Texture();*/
   }
   else
Index: trunk/src/lib/graphics/importer/material.h
===================================================================
--- trunk/src/lib/graphics/importer/material.h	(revision 9682)
+++ trunk/src/lib/graphics/importer/material.h	(revision 9869)
@@ -24,11 +24,12 @@
 class Material : public BaseObject
 {
+  ObjectListDeclaration(Material);
 public:
   Material (const std::string& mtlName = "");
   virtual ~Material ();
 
+  Material& operator=(const Material& material);
+
   void loadParams(const TiXmlElement* root);
-
-  Material& operator=(const Material& material);
 
   bool select () const;
@@ -53,5 +54,5 @@
   // MAPPING //
   void setDiffuseMap(const Texture& texture, unsigned int textureNumber = 0);
-  void setDiffuseMap(const TextureDataPointer& texturePointer, unsigned int textureNumber = 0);
+  void setDiffuseMap(const TextureData::Pointer& texturePointer, unsigned int textureNumber = 0);
   void setDiffuseMap(const std::string& dMap, GLenum target = GL_TEXTURE_2D, unsigned int textureNumber = 0);
   void setSDLDiffuseMap(SDL_Surface *surface, GLenum target = GL_TEXTURE_2D, unsigned int textureNumber = 0);
@@ -65,6 +66,4 @@
 
   const Texture& diffuseTexture(unsigned int i = 0) const { return this->textures[i]; };
-
-  static void addTexturePath(const std::string& pathName);
 
   static const std::string& blendFuncToString(GLenum blendFunc);
